#ifndef _XPEPM_H

#define _XPEPM_H

// +++**************************************************************************
//
//  Copyright (c) 2001  Microsoft Corporation
//
//  Module Name:
//    xpepm.h
//
//  Abstract:
//    XPEPM.DLL provides the application developer a method to set system power
//    states for systems using the MinLogOn component.  These states are set via
//    native mode API calls.
//
//***************************************************************************---

// +++**************************************************************************
//   Prototypes
//***************************************************************************---


// +++**************************************************************************
// XPE_ReStart
//
// Purpose: 
//    This will Restart the system.
//
// Return Value:
//    WIN32 DWORD error code
//
//***************************************************************************---
DWORD 
WINAPI
XPE_ReStart(
    void
    );

// +++**************************************************************************
// XPE_Shutdown
//
// Purpose: 
//    This will shutdown the system
//
// Return Value:
//    WIN32 DWORD error code
//
//***************************************************************************---
DWORD 
WINAPI
XPE_Shutdown(
    void
    );

// +++**************************************************************************
// XPE_StandBy
//
// Purpose: 
//    This will set the system to its lowest possible Sx state
//
// Arguments:
//    bForceState - BOOL value for whether we allow the system devices to respond
//      or force the system down w/o waiting for the response
//
// Return Value:
//    WIN32 DWORD error code
//
//***************************************************************************---
DWORD 
WINAPI
XPE_StandBy(
    IN BOOL bForceState
    );

// +++**************************************************************************
// XPE_Hibernate
//
// Purpose: 
//    This will set the system to hibernate
//
// Arguments:
//    bForceState - BOOL value for whether we allow the system devices to respond
//      or force the system down w/o waiting for the response
//
// Return Value:
//    WIN32 DWORD error code
//
//***************************************************************************---
DWORD 
WINAPI
XPE_Hibernate(
    IN BOOL bForceState
    );
    
#endif

